﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using Telerik.WinControls.UI;

namespace _978950_RadGridViewPrintingHeaders
{
    public class CustomGridHeaderCellElement : GridHeaderCellElement
    {
        public CustomGridHeaderCellElement(GridViewColumn column, GridRowElement row)
            : base(column, row)
        {
        }

        protected override Type ThemeEffectiveType
        {
            get
            {
                return typeof(GridHeaderCellElement);
            }
        }

        protected override void ProcessDragDrop(System.Drawing.Point dropLocation, Telerik.WinControls.ISupportDrag dragObject)
        {
            object dataObjectContext = dragObject.GetDataContext();
            RadPosition dropPosition = DragDropHelper.GetDropPosition(dropLocation, this.Size);
            if (dataObjectContext is GridViewDataColumn)
            {
                GridViewDataColumn draggedColumn = dataObjectContext as GridViewDataColumn;
                GridViewColumnCollection columns = this.Data.OwnerTemplate.Columns;

                if (!draggedColumn.IsVisible)
                {
                    draggedColumn.IsVisible = true;
                }

                ColumnGroupsViewDefinition view = ViewTemplate.ViewDefinition as ColumnGroupsViewDefinition;
                if (view != null)
                {
                    DropInColumnGroupsView(view, draggedColumn, dropPosition);
                }
                else
                {
                    draggedColumn.PinPosition = this.ColumnInfo.PinPosition;
                    if (!this.RightToLeft)
                    {
                        DragDropHelper.MoveOnLeftOrRight((dropPosition & RadPosition.Left) != 0, columns, this.Data as GridViewDataColumn, draggedColumn);
                    }
                    else
                    {
                        DragDropHelper.MoveOnLeftOrRight((dropPosition & RadPosition.Right) != 0, columns, this.Data as GridViewDataColumn, draggedColumn);
                    }
                }
            }
            else if (dataObjectContext is GroupFieldDragDropContext)
            {
                GroupFieldDragDropContext groupFieldDragDrop = dataObjectContext as GroupFieldDragDropContext;
                MethodInfo miDragDropSortDescription = typeof(GridHeaderCellElement).GetMethod("DragDropSortDescription", BindingFlags.Instance | BindingFlags.NonPublic);
                miDragDropSortDescription.Invoke(this, new object[] { groupFieldDragDrop, dropPosition });
            }
        }
    }
}
